<template>
  <table v-if="backReferences">
    <tr>
      <th>Bron</th>
      <th>Concept</th>
    </tr>
    <tr v-for="(ref, index) in backReferences" :key="index"
        v-on:click="concept_clicked(ref.concept)" class="pointer"
        :class="{active: current===ref.concept.id}">
      <td class="detail_bg">
        <span style="white-space: nowrap;">
          <q-icon v-if="current===ref.concept.id" name="arrow_right" size="30"></q-icon>
          {{ ref.source }}
        </span>
      </td>
      <td class="detail_bg">{{ ref.concept_name }}</td>
    </tr>
  </table>
</template>

<script>
import {api} from "boot/axios";

export default {
  name: "ReferenceBackreference",
  data() {
    return {
      backReferences: undefined,
      current: undefined
    }
  },
  props: {
    reference_id: String,
    dts_name: String,
    nt_version: String
  },
  mounted() {
    if (this.reference_id && this.dts_name) {
      this.fetchData()
    }
  },
  watch: {
    reference_id: function () {
      if (this.reference_id && this.dts_name) {
        this.fetchData()
      }
    }
  },
  methods: {
    fetchData: function () {
      if (this.reference_id && this.dts_name) {
        api
          .get("/dts/" + this.dts_name + "/references/backref/" + this.reference_id,
            {params: {nt_version: this.nt_version}})
          .then(response => {
            this.backReferences = response.data
            if (this.backReferences.length) {
              this.concept_clicked(this.backReferences[0].concept)
            }
          })
      }
    },
    concept_clicked: function (concept) {
      this.current = concept.id
      this.$emit('conceptClicked', concept)
    }
  },
  emits: ["conceptClicked"]
}
</script>

<style scoped lang="scss">

.pointer {
  cursor: pointer;
}

th {
  text-align: left;
}

table {
  border-collapse: collapse;
}

td, th {
  border: 1px solid $blue-grey;
  padding: 2px 5px;
}

tr.pointer:hover {
  background-color: $list_selected_bg;
  opacity: 0.8;
  color: white;
}

tr.pointer:hover td {
  background: transparent;
}

tr.pointer .active,
.active > .detail_bg {
  background-color: transparent;
}
</style>
